const assert = require('assert')
/*! AnabolicSet v1.2.0 | (c) ColonelParrot and other contributors | MIT License */
class AnabolicSet{constructor(e,s,t){void 0!==s?this.setSerializer(s):this.setSerializer(e=>e),this.setValues(e),this.options=t||{}}setValues(e){const s=e=>{this._values=e.reduce((e,s)=>(e[this.serializer(s)]=s,e),{})};void 0!==e?(this.clear(),Array.isArray(e)?s(e):s([e])):this.clear()}add(e){void 0!==e&&(this._values[this.serializer(e)]=e)}addAll(...e){void 0!==e&&e.forEach(e=>{this._values[this.serializer(e)]=e})}clear(){this._values={}}delete(e){void 0!==e&&delete this._values[this.serializer(e)]}entries(){return Object.values(this._values).reduce((e,s)=>(e.push([s,s]),e),[])}forEach(e){Object.values(this._values).forEach(e)}has(e){return this._values.hasOwnProperty(this.serializer(e))}values(){return Object.values(this._values)}keys(){return this.values()}setSerializer(e){this.serializer=e}union(e){if(void 0!==e){const s={...this._values},t={...e.values};return Object.values(t).forEach(e=>{const t=this.serializer(e);s[t]=e}),new AnabolicSet(Object.values(s),this.serializer)}}intersect(e){return Object.keys(this._values).reduce((s,t)=>(e.values.hasOwnProperty(t)&&s.push(this._values[t]),s),[])}complement(e){return Object.keys(this._values).reduce((s,t)=>(e.values.hasOwnProperty(t)||s.push(this._values[t]),s),[])}isSubsetOf(e){return 0==this.complement(e).length}isSupersetOf(e){return e.isSubsetOf(this)}clone(){return new AnabolicSet({...this._values},this.serializer)}}

function set(...rest) {
    return new AnabolicSet(...rest)
}

describe('constructor() test', () => {
    it('should remove duplicate numbers', () => {
        assert.deepEqual(set([1, 2, 2, 3]).values(), [1, 2, 3])
    })
    it('should remove duplicate ids', () => {
        assert.deepEqual(set([{ id: 1 }, { id: 2 }, { id: 2 }], (obj) => obj.id).values(), [{ id: 1 }, { id: 2 }])
    })
    it('should handle object parameter', () => {
        assert.deepEqual(set({ a: 'a', b: 'b', c: 'c' }).values(), ['a', 'b', 'c'])
    })
    it('should handle primitive data type parameter', () => {
        assert.deepEqual(set(1).values(), [1])
        assert.deepEqual(set('1').values(), ['1'])
    })
})

describe('add() test', () => {
    it('should handle array parameter', () => {
        const s = set([1, 2, 3])
        s.add([2, 3, 4])
        assert.deepEqual(s.values(), [1, 2, 3, 4])
    })
    it('should handle object parameter', () => {
        const s = set([1, 2, 3])
        s.add({ four: 4, five: 5, six: 6 })
        assert.deepEqual(s.values(), [1, 2, 3, 4, 5, 6])
    })
    it('should handle primitive data type parameter', () => {
        const s = set([1, 2, 3])
        s.add(4)
        assert.deepEqual(s.values(), [1, 2, 3, 4])
    })
})

describe('clear() test', () => {
    it('should be empty', () => {
        const s = set([1, 2, 3])
        s.clear()
        assert.deepEqual(s.values(), [])
    })
})

describe('delete() test', () => {
    it('should handle primitive data type parameter', () => {
        const s = set([1, 2, 3])
        s.delete(1)
        assert.deepEqual(s.values(), [2, 3])
    })
})

describe('entries() test', () => {
    it('should give entries', () => {
        const s = set([1, 2, 3])
        assert.deepEqual(s.entries(), [[1, 1], [2, 2], [3, 3]])
    })
})

describe('has() test', () => {
    it('should have number', () => {
        const s = set([1, 2, 3])
        assert.equal(s.has(3), true)
    })
    it('should not have string', () => {
        const s = set([1, 2, 3])
        assert.equal(s.has('4'), false)
    })
})